chiark / gitweb /
Xdefaults: Spruce up somewhat.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
116echo " all done."
117
118###--------------------------------------------------------------------------
119### Install global configuration.
120
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
129## Symlink the various dotfiles into place
130dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el
133 vimrc mg zile
134 mailrc signature
135 cgrc tigrc
136 gdbinit
137 guile
138 toprc
139 aspell.conf
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
143 lisp-init.lisp:.eclrc
144 swank.lisp
145 dircolors colordiffrc screenrc cvsrc indent.pro"
146[ "$xstuff" ] && dotfiles="$dotfiles
147 xinitrc xsession Xdefaults vncrc vncsession
148 fonts.conf
149 putty-defaults:.putty/sessions/Default%20Settings
150 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
151 e-keybindings.cfg:.enlightenment/keybindings.cfg
152 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
153 e16-bindings:.e16/bindings.cfg
154 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg
155 jue-peek.jpg:.e16/backgrounds/jue-peek.jpg"
156echo "Installing dotfiles..."
157for d in $dotfiles; do
158 target=.$d
159 case $d in
160 *:*) target=${d#*:} d=${d%%:*};;
161 esac
162 ft=$HOME$sub/$target
163 dir=${ft%/*}
164 mkdir -p $dir
165 ln -s $here/$d $ft.new
166 mv $ft.new $ft
167 echo " $target"
168done
169echo " all done."
170
171###--------------------------------------------------------------------------
172### Process the Git configuration.
173
174echo -n "Installing Git configuration:"
175sed "
1761i\
177### generated by $here/setup; do not edit!\
178
179/@releasekey@/ s::$(./mdw-conf release-key 481334C2):g
180/@gitignore@/ s::$(./mdw-conf gitignore $here/gitignore):g
181" gitconfig >$HOME/.gitconfig.new
182mv $HOME/.gitconfig.new $HOME/.gitconfig
183echo " done."
184
185###--------------------------------------------------------------------------
186### Install useful scripts included in this package.
187
188scripts="
189 mdw-editor
190 mdw-pager
191 mdw-conf
192 mdw-build
193 movemail-hack
194 emerge-hack
195 lesspipe.sh
196 start-ssh-agent
197 svnwrap
198 hyperspec"
199[ "$xstuff" ] && scripts="$scripts
200 xinitcmd
201 un-backslashify-selection
202 xshutdown"
203echo "Installing scripts..."
204mkdir -p $HOME$sub/bin
205for s in $scripts; do
206 ft=$HOME$sub/bin/$s
207 ln -s $here/$s $ft.new
208 mv $ft.new $ft
209 echo " $s"
210done
211echo " all done."
212
213###--------------------------------------------------------------------------
214### Set up the Emacs config.
215
216$echon "Finding a suitable emacs:$echoc"
217emacs=no
218for i in emacs22 emacs21 emacs; do
219 if type -p >/dev/null $i; then
220 emacs=$i
221 break
222 fi
223done
224if [ $emacs = no ]; then
225 echo " failed."
226 emacs=:
227else
228 echo " $emacs."
229fi
230
231echo "Installing Emacs packages..."
232emacspkg="
233 make-regexp
234 ew-hols
235 mdw-gnus-patch
236 git git-blame vc-git stgit
237 quilt"
238for elib in $emacspkg; do
239 $echon " $elib:$echoc"
240 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
241 (progn
242 (setq load-path (nconc load-path (list "~/lib/emacs")))
243 (kill-emacs (condition-case nil
244 (progn (load-library "'"$elib"'") 0)
245 (error 1))))'; then
246 echo " already installed."
247 else
248 if [ -f $elib.el ]; then
249 cp $elib.el $HOME$sub/lib/emacs/$elib.el
250 else
251 $echon " downloading$echoc"
252 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
253 fi
254 $echon " compiling$echoc"
255 (cd $HOME$sub/lib/emacs;
256 $emacs >/dev/null 2>&1 --no-site-file --batch \
257 --eval '(byte-compile-file "'"$elib.el"'")')
258 echo " done."
259 fi
260done
261echo " all done."
262
263$echon "Setting up Emacs configuration:$echoc"
264$echon " linking$echoc"
265for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
266 set -- $(echo $link | tr : ' ')
267 from=$1 to=$2
268 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
269 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
270done
271$echon " compiling$echoc"
272make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
273echo " done."
274
275###----- That's all, folks --------------------------------------------------